#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
Individualizacion de cada cam,probar a quitar sistema recursivo de cams.
a traves de una clase de tipo thread

al reiniciar al webcams fallan
Programo con un falso sistema de apagado puesto
que lo thread siguen funcionando por detras
"""

import scanner
import mixer
import sys
import os
import time
import threading
import midi
import player
import operator
import mysocket


class Control:
    """
    Clase principal
    """
    def __init__(self, numsala):
        self.numsala = numsala
        self.mixer = mixer.Mixer(0, numsala)
        self.sala = []
        self.capture = []
        self.player = player.Player()
        self.midi = midi.Launchpad()
        self.midi.Start()
        self.scan_active = True

    """
    Control secuencial de la webcams
    """
    def init_cam(self):
        #Inicializacion webcams
        for i in range(0, self.numsala):
            self.sala.append(scanner.Scanner(i + 1))
            self.sala[i].PhotoCalibrate()
            self.capture.append(self.sala[i].AppSub_RGB_init())
        self.mixer.ShutUpVolume()

    def control_sound(self):
        #Loop evaluacion
        while True:
            if self.scan_active:
                for i in range(0, self.numsala):
                    if self.sala[i].AppSub_RGB(self.capture[i]):
                        self.mixer.SoundChannel(i + 1)
                    else:
                        self.mixer.TurnOffChannel(i + 1)
                    #Evita sobre saturacion del sistema
                    time.sleep(0.005)

    def scan(self):
        sala = threading.Thread(target=self.control_sound, args=())
        sala.start()

    """
    Faders de monitorado
    """
    def midi_level(self, channel):
        volume_inicial = self.mixer.GetVolume(channel)[0]
        self.midi.Midi_paint(channel, volume_inicial, 'green')
        while True:
            volume_actual = self.mixer.GetVolume(channel)[0]
            if volume_actual != volume_inicial:
                volume_inicial = volume_actual
                self.midi.Midi_paint(channel, volume_inicial, 'green')

    def master_level(self):
        volume_inicial = self.mixer.GetMaster()[0]
        self.midi.Midi_paint(4, volume_inicial, 'amber')
        while True:
            volume_actual = self.mixer.GetMaster()[0]
            if volume_actual != volume_inicial:
                volume_inicial = volume_actual
                self.midi.Midi_paint(4, volume_inicial, 'amber')

    def in_master(self, level):
        level = (level / 16)
        if level == 0:
            self.mixer.SetMaster(100)
        elif level == 1:
            self.mixer.SetMaster(90)
        elif level == 2:
            self.mixer.SetMaster(81)
        elif level == 3:
            self.mixer.SetMaster(71)
        elif level == 4:
            self.mixer.SetMaster(61)
        elif level == 5:
            self.mixer.SetMaster(39)
        elif level == 6:
            self.mixer.SetMaster(19)
        elif level == 7:
            self.mixer.SetMaster(0)

    """
    Inicializador midi
    """
    def init_midi(self):
        #Player
        self.midi.Writer(5, 60)
        self.midi.Writer(6, 63)
        self.midi.Writer(7, 15)
        self.midi.Writer(21, 61)
        self.midi.Writer(22, 61)
        self.midi.Writer(53, 15)
        #Niveles de volumen
        launchpad = []
        for i in range(0, self.numsala):
            launchpad.append(threading.Thread(target=self.midi_level,
                                                args=(i + 1, )))
            launchpad[i].start()
        master = threading.Thread(target=self.master_level, args=())
        master.start()

    #Gestiona entradas y salidas midi
    def core(self):
        while 1 != 0:
            key = self.midi.Reader()
            if key == 111:
                self.player.stop()
                self.midi.Get_Out()
                self.scan_active = False
                break
            if key == 5:
                self.player.play()
                self.player.play_list()
            if key == 6:
                self.player.pause()
            if key == 7:
                self.player.stop()
            if key == 21:
                self.player.previous()
            if key == 22:
                self.player.next()
            if (operator.mod(key, 8)) + 1 == 4:
                self.in_master(key)
        self.Start()

    """
    Maquina de estados
    """
    def Start(self, mode='run'):
        print "Inicio programa"
        self.midi.Get_Init()
        print "Enciendo luces"
        self.init_midi()
        if mode == 'start':
            print "Activo webcams"
            self.init_cam()
            print "Enciendo el reproductor"
            self.player.start()
            print "Monitorado de la webcam"
            self.scan()
        if mode == 'run':
            print 'Reactivamos webcams'
            self.scan_active = True
        print "Entro a core"
        self.core()

"""
Programa principal
"""
if __name__ == '__main__':
    if len(sys.argv) != 2:
        print chr(27) + "[3;31m" + \
        "Usage: Numero de salas" + chr(27) + "[0m"
        sys.exit()
    else:
        try:
            sistema = Control(int(sys.argv[1]))
            sistema.Start('start')
        except KeyboardInterrupt:
            print 'Bye.'
